<!-- Begin Air Publisher Each html Template -->

<!-- Intro Content -->
%%[[if !edit]]%%
<?php
  ob_start(); 
  // Get values from the stack...
  $apiKey = "%id=apiKey%";
  $baseID = "%id=baseID%";
  $table = "%id=table%";
  $recordID = "%id=recordID%";
  $queryParam = "%id=queryParam%";
  $fields = "%id=fields%";
  $filterByFormula = "%id=filterByFormula%";
  $maxRecords = "%id=maxRecords%";
  $pageSize = "%id=pageSize%";
  $sortField = "%id=sortField%";
  $sortOrder = "%id=sortOrder%";
  $view = "%id=view%";
  $cellFormat = "%id=cellFormat%";
  $timeZone = "%id=timeZone%";
  $userLocale = "%id=userLocale%";
  $offset = "%id=offset%";
  $tokenStyle = "%id=tokenStyle%";
  $debug = %id=debug%;
  $showFields = %id=showFields%;
  $urlExtraParams = "%id=urlExtraParams%";

  // Set the token prefix / suffix based on the token style...
  if ( $tokenStyle == 'brackets' ) {
    $tokenPrefix = '[[';
    $tokenSuffix = ']]';
  } elseif ( $tokenStyle == 'tags' ) {
    $tokenPrefix = '<<';
    $tokenSuffix = '>>';  
  } else {
    $tokenPrefix = '{{';
    $tokenSuffix = '}}';  
  }
?>
%%[[endif]]%%

%%[[if edit]]%%
<div class='border'>
  %[if %id=showDescription%]%
    <h3 class='header success'>Intro Stacks</h3>
    <p class="description">These stacks will be displayed before the list of records.</p>
  %[else]%
    <div class="shortHeader success">Intro Stacks</div>
  %[endif]%
%%[[endif]]%%
%slice%
%%[[if !edit]]%%
<?php
  $introTemplate = ob_get_contents();
  ob_end_clean();   
?>
%%[[endif]]%%
%%[[if edit]]%%
</div>
%%[[endif]]%%

<!-- Records Content -->
%%[[if !edit]]%%
<?php
  ob_start(); 
?>
%%[[endif]]%%
%%[[if edit]]%%
<div class='border'>
  %[if %id=showDescription%]%
    <h3 class='header success'>Record List Stacks</h3>
    <p class="description">
      These stacks will be displayed for every result item of the list of records. 
      Reference fields with curly brackets: <kbd>{{Field Name}}</kbd>.
    </p>
  %[else]%
    <div class="shortHeader success">Record List Stacks</div>
  %[endif]%
%%[[endif]]%%
%slice%
%%[[if !edit]]%%
<?php
  $recordTemplate = ob_get_contents();
  ob_end_clean();   
?>
%%[[endif]]%%
%%[[if edit]]%%
</div>
%%[[endif]]%%

<!-- Outro Content -->
%%[[if !edit]]%%
<?php
  ob_start(); 
?>
%%[[endif]]%%
%%[[if edit]]%%
<div class='border'>
  %[if %id=showDescription%]%
    <h3 class='header success'>Outro Stacks</h3>
    <p class="description">These stacks will be displayed after the list of records.</p>
  %[else]%
    <div class="shortHeader success">Outro Stacks</div>
  %[endif]%
%%[[endif]]%%
%slice%
%%[[if !edit]]%%
<?php
  $outroTemplate = ob_get_contents();
  ob_end_clean();   
?>
%%[[endif]]%%
%%[[if edit]]%%
</div>
%%[[endif]]%%

<!-- No Records Found Content -->
%%[[if !edit]]%%
<?php
  ob_start(); 
?>
%%[[endif]]%%
%%[[if edit]]%%
<div class='border'>
  %[if %id=showDescription%]%
    <h3 class='header failure'>No Records</h3>
    <p class="description">These stacks will be displayed if no records are returned by the API.</p>
  %[else]%
    <div class="shortHeader failure">No Records</div>
  %[endif]%
%%[[endif]]%%
%slice%
%%[[if !edit]]%%
<?php
  $errorTemplate = ob_get_contents();
  ob_end_clean();   
?>
%%[[endif]]%%

%%[[if !edit]]%%
<?php

  // Create the URL to use.
  $url = 'https://api.airtable.com/v0/';
  
  // If no base ID was specified...
  if ( $baseID == '' ) {
    die( 'Please specify a Base ID.' );
  } 
  
  // Add the base ID. 
  $url .= $baseID . '/';
  
  // If no table was specified...
  if ( $table == '' ) {
    die( 'Please specify a Table.' );
  } 
  
  // Add the table. 
  $url .= rawurlencode( $table ); 
  
  // If a record ID was specified...
  if ( $recordID != '' ) {
    $url .= '/' . $recordID . '/';
  }
  
  // HK: if record id is sent via query param
  if ( $queryParam != '' && isset($_GET[$queryParam]) ) {
    $url .= '/' . $_GET[$queryParam] . '/';
  }
  
  // Begin parameters.
  $url .= '?';
  
  // If specific fields are to be retrieved...
  // And if this isn't a request for a specific record...
  // Note: The features are incompatible. 
  if ( ( $fields != '' ) and ( $recordID == '' ) and (!isset($_GET[$queryParam])) ) { 
    $fields = str_replace( ', ', ',', $fields );
    $fields = explode( ',', $fields );
    foreach ( $fields as $field ) {
      $url .= '&fields%5B%5D=' . urlencode( $field );
    }     
  }
  
  // If a filter is to be applied...
  if ( ( $filterByFormula != '' ) and ( $recordID == '' ) and (!isset($_GET[$queryParam])) ) {  
    $url .= '&filterByFormula=' . urlencode( $filterByFormula );
  }
  
  // If a maxRecords was specified...
  if ( ( $maxRecords != '' ) and ( $recordID == '' ) and (!isset($_GET[$queryParam])) ) { 
    $url .= '&maxRecords=' . $maxRecords;
  } 
  
  // If a pageSize was specified...
  if ( ( $pageSize != '' ) and ( $recordID == '' ) and (!isset($_GET[$queryParam])) ) { 
    $url .= '&pageSize=' . $pageSize;
  } 
  
  // If a sort field was specified...
  if ( ( $sortField != '' ) and ( $recordID == '' ) and (!isset($_GET[$queryParam])) ) {  
    $url .= '&sort[0][field]=' . urlencode( $sortField );
    $url .= '&sort[0][direction]=' . urlencode( $sortOrder );   
  } 
  
  // If a view was specified...
  if ( $view != '' ) {  
    $url .= '&view=' . urlencode( $view );
  }   
  
  // Add the cell format.
  $url .= '&cellFormat=' . $cellFormat;
  
  // If a timeZone was specified...
  if ( $timeZone != '' ) {  
    $url .= '&timeZone=' . urlencode( $timeZone );
  } 
  
  // If a userLocale was specified...
  if ( $userLocale != '' ) {  
    $url .= '&userLocale=' . urlencode( $userLocale );
  }     
  
  // If an offset was specified...
  if ( $offset != '' ) {  
    $url .= '&offset=' . urlencode( $offset );
  }   
  
  // If any additional parameters were specified...
  if ( $urlExtraParams != '' ) {  
    $url .= '&' & $urlExtraParams;
  } 
  
  // Create and configure a cURL instance.
  $ch = curl_init();
  curl_setopt( $ch, CURLOPT_URL, $url );
  curl_setopt( $ch, CURLOPT_CUSTOMREQUEST, 'GET' );
  curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1 );
  curl_setopt( $ch, CURLOPT_HTTPHEADER, [ 'Authorization: Bearer ' . $apiKey ] );

  // Send the API request and get the response.
  $response = curl_exec( $ch );
  // echo '<pre>'; var_dump( $response ); echo '</pre>'; die;
  
  // Close the cURL object.
  curl_close ($ch); 

  // Convert the JSON-encoded response to an array.
  $response = json_decode( $response, TRUE );
  // echo '<pre>'; var_dump( $response ); echo '</pre>'; die;

  // If the response included only a single record...
  if ( array_key_exists( 'fields', $response ) ) {
    $records = array();
    $records[0] = $response;
  } elseif ( array_key_exists( 'records', $response ) ) {
    $records = $response['records'];
  }
  // echo '<pre>'; var_dump( $records ); echo '</pre>'; die;
    
  // If an error occurred...
  if ( array_key_exists ( 'error', $response ) ) {

    // Display the error content.
    echo $errorTemplate;
    
    // If we're to display debug information, and if we're viewing the page locally...
    if ( ( $debug ) && ( $_SERVER['REMOTE_ADDR'] == '127.0.0.1' ) ) {
  
      echo '<div style="background-color: red; color: white; margin-top: 24px; margin-bottom: 24px; padding: 9px;">' . PHP_EOL;
      echo '<span style="font-weight: bold;">Debug Information</span><br>' . PHP_EOL;
      echo '&bull; Error Type: ' . $response['error']['type'] . '<br>' . PHP_EOL;
      echo '&bull; Error Message: ' . $response['error']['message'] . '<br>' . PHP_EOL;
      echo '&bull; API URL: ' . $url . '<br>' . PHP_EOL;
      echo '</div>' . PHP_EOL;  
  
    } 
    
  } elseif ( ( $showFields == 'true' ) && ( $_SERVER['REMOTE_ADDR'] == '127.0.0.1' ) ) {  
  
    // Initialize the content that will actually be displayed.
    $content = '<h1>Fields</h1>' . PHP_EOL;
  
    // Get the first record's fields.   
    $fields = $records[0]['fields'];    
    // echo '<pre>'; var_dump( $fields ); echo '</pre>'; die;
  
    // Loop over the fields...
    foreach ( $fields as $key => $value ) { 
      $content .= '<p>';
      $content .= '<span style="font-weight: bold;">' . $key . '</span><br>';
      $content .= '&bull; Token: ' . $tokenPrefix . $key . $tokenSuffix . '<br>';
      $content .= '&bull; Example: ' . $value;
      $content .= '</p>';
    }
    
    echo $content;
  
  } else {
  
    // Initialize the content that will actually be displayed.
    $content = '';
    
    // If a single record was returned...
    if ( array_key_exists( 'id', $response ) ) {
      $response['records'][0] = $response;
    }
    
    // Initialize the record number.
    $recordNumber = 0;
      
    // Loop over the records...
    foreach ( $records as $record ) {
        
      // Increment the record number.
      $recordNumber = $recordNumber + 1;      
        
      // Initialize the content for this record.
      $recordContent = $recordTemplate;
      
      // Replace the recordNumber token.
      $recordContent = str_replace( $tokenPrefix . 'recordNumber' . $tokenSuffix, $recordNumber, $recordContent );
      
      // Replace the record-level values.
      $recordContent = str_replace( $tokenPrefix . 'recordID' . $tokenSuffix, $record['id'], $recordContent );
      $recordContent = str_replace( $tokenPrefix . 'createdTime' . $tokenSuffix, $record['createdTime'], $recordContent );      
  
      // Get the record's fields.
      $fields = $record['fields'];
  
      // Loop over the fields...
      foreach ( $fields as $key => $value ) {
        
        // Replace all occurrences of the token key with its value.
        $recordContent = str_replace( $tokenPrefix . $key . $tokenSuffix, $value, $recordContent);    
      
      }
          
      // Add this record's content to the overall content.
      $content .= $recordContent;
    
    }
    
    // Build the full content to be displayed.
    $content = $introTemplate . PHP_EOL . $content . PHP_EOL . $outroTemplate;
    
    // Replace any additional tokens that are supported.
    $content = str_replace( $tokenPrefix . 'recordCount' . $tokenSuffix, count( $response['records'] ), $content );
    $content = str_replace( $tokenPrefix . 'offset' . $tokenSuffix, $response['offset'], $content );  
    
    // Comment out any empty tokens.
    $content = str_replace( $tokenPrefix, '<!-- ', $content );
    $content = str_replace( $tokenSuffix, ' -->', $content ); 
    
    // Display the content with the substituted tokens.
    echo $content;
      
  }

?>
%%[[endif]]%%

<!-- End Air Publisher Each html Template -->